import { Operation } from '@kubb/oas';
import { OperationSchemas } from '@kubb/plugin-oas';
import { ReactNode } from 'react';
import { P as PluginVueQuery, I as Infinite } from './types-CmetQDTc.js';
import { FunctionParams } from '@kubb/react';
import '@kubb/core';

type Props$5 = {
    /**
     * Name of the function
     */
    name: string;
    typeName: string;
    clientName: string;
    typeSchemas: OperationSchemas;
    operation: Operation;
    dataReturnType: PluginVueQuery['resolvedOptions']['client']['dataReturnType'];
    pathParamsType: PluginVueQuery['resolvedOptions']['pathParamsType'];
};
declare function Mutation({ name, clientName, pathParamsType, dataReturnType, typeSchemas, operation }: Props$5): ReactNode;

type Props$4 = {
    /**
     * Name of the function
     */
    name: string;
    queryOptionsName: string;
    queryKeyName: string;
    queryKeyTypeName: string;
    typeSchemas: OperationSchemas;
    operation: Operation;
    pathParamsType: PluginVueQuery['resolvedOptions']['pathParamsType'];
    dataReturnType: PluginVueQuery['resolvedOptions']['client']['dataReturnType'];
};
type GetParamsProps$4 = {
    pathParamsType: PluginVueQuery['resolvedOptions']['pathParamsType'];
    dataReturnType: PluginVueQuery['resolvedOptions']['client']['dataReturnType'];
    typeSchemas: OperationSchemas;
};
declare function Query({ name, queryKeyTypeName, queryOptionsName, queryKeyName, pathParamsType, dataReturnType, typeSchemas, operation }: Props$4): ReactNode;
declare namespace Query {
    var getParams: ({ pathParamsType, dataReturnType, typeSchemas }: GetParamsProps$4) => FunctionParams;
}

type Props$3 = {
    name: string;
    typeName: string;
    typeSchemas: OperationSchemas;
    operation: Operation;
    pathParamsType: PluginVueQuery['resolvedOptions']['pathParamsType'];
    keysFn: ((keys: unknown[]) => unknown[]) | undefined;
};
type GetParamsProps$3 = {
    pathParamsType: PluginVueQuery['resolvedOptions']['pathParamsType'];
    typeSchemas: OperationSchemas;
};
declare function QueryKey({ name, typeSchemas, pathParamsType, operation, typeName, keysFn }: Props$3): ReactNode;
declare namespace QueryKey {
    var getParams: ({ pathParamsType, typeSchemas }: GetParamsProps$3) => FunctionParams;
}

type Props$2 = {
    name: string;
    clientName: string;
    queryKeyName: string;
    typeSchemas: OperationSchemas;
    pathParamsType: PluginVueQuery['resolvedOptions']['pathParamsType'];
};
type GetParamsProps$2 = {
    pathParamsType: PluginVueQuery['resolvedOptions']['pathParamsType'];
    typeSchemas: OperationSchemas;
};
declare function QueryOptions({ name, clientName, typeSchemas, pathParamsType, queryKeyName }: Props$2): ReactNode;
declare namespace QueryOptions {
    var getParams: ({ pathParamsType, typeSchemas }: GetParamsProps$2) => FunctionParams;
}

type Props$1 = {
    name: string;
    clientName: string;
    queryKeyName: string;
    typeSchemas: OperationSchemas;
    pathParamsType: PluginVueQuery['resolvedOptions']['pathParamsType'];
    dataReturnType: PluginVueQuery['resolvedOptions']['client']['dataReturnType'];
    initialPageParam: Infinite['initialPageParam'];
    cursorParam: Infinite['cursorParam'];
    queryParam: Infinite['queryParam'];
};
type GetParamsProps$1 = {
    pathParamsType: PluginVueQuery['resolvedOptions']['pathParamsType'];
    typeSchemas: OperationSchemas;
};
declare function InfiniteQueryOptions({ name, clientName, initialPageParam, cursorParam, typeSchemas, dataReturnType, pathParamsType, queryParam, queryKeyName, }: Props$1): ReactNode;
declare namespace InfiniteQueryOptions {
    var getParams: ({ pathParamsType, typeSchemas }: GetParamsProps$1) => FunctionParams;
}

type Props = {
    /**
     * Name of the function
     */
    name: string;
    queryOptionsName: string;
    queryKeyName: string;
    queryKeyTypeName: string;
    typeSchemas: OperationSchemas;
    operation: Operation;
    pathParamsType: PluginVueQuery['resolvedOptions']['pathParamsType'];
    dataReturnType: PluginVueQuery['resolvedOptions']['client']['dataReturnType'];
};
type GetParamsProps = {
    pathParamsType: PluginVueQuery['resolvedOptions']['pathParamsType'];
    dataReturnType: PluginVueQuery['resolvedOptions']['client']['dataReturnType'];
    typeSchemas: OperationSchemas;
};
declare function InfiniteQuery({ name, queryKeyTypeName, queryOptionsName, queryKeyName, pathParamsType, dataReturnType, typeSchemas, operation, }: Props): ReactNode;
declare namespace InfiniteQuery {
    var getParams: ({ pathParamsType, dataReturnType, typeSchemas }: GetParamsProps) => FunctionParams;
}

export { InfiniteQuery, InfiniteQueryOptions, Mutation, Query, QueryKey, QueryOptions };
